OpenTTD Source: StoryPage Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Data Fields
StoryPage Struct Reference

Struct about stories, current and completed. More...

`#include <story_base.h>`

Inheritance diagram for StoryPage:

## Public Member Functions
| StoryPage ()
| We need an (empty) constructor so struct isn't zeroed (as C++ standard states)
| StoryPage (uint32_t sort_value, TimerGameCalendar::Date date, CompanyID company, const EncodedString &title)
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_story_page_pool >
void * | operator new (size_t size)
| Allocates space for new Titem.
void * | operator new (size_t size, Tindex index)
| Allocates space for new Titem with given index.
void * | operator new (size_t, void *ptr)
| Allocates space for new Titem at given memory address.
void | operator delete (void *p, size_t size)
| Marks Titem as free.

## Data Fields
uint32_t | sort_value = 0
| A number that increases for every created story page. Used for sorting. The id of a story page is the pool index.
TimerGameCalendar::Date | date {}
| Date when the page was created.
CompanyID | company = CompanyID::Invalid()
| StoryPage is for a specific company; CompanyID::Invalid() if it is global.
EncodedString | title
| Title of story page.
Data Fields inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_story_page_pool >
Tindex | index
| Index of this pool item.

## Additional Inherited Members
Public Types inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_story_page_pool >
typedef struct Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache > | Pool
| Type of the pool this item is going to be part of.
Static Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_story_page_pool >
static bool | CanAllocateItem (size_t n=1)
| Helper functions so we can use PoolItem::Function() instead of _poolitem_pool.Function()
static bool | CleaningPool ()
| Returns current state of pool cleaning - yes or no.
static bool | IsValidID (auto index)
| Tests whether given index can be used to get valid (non-nullptr) Titem.
static Titem * | Get (auto index)
| Returns Titem with given index.
static Titem * | GetIfValid (auto index)
| Returns Titem with given index.
static size_t | GetPoolSize ()
| Returns first unused index.
static size_t | GetNumItems ()
| Returns number of valid items in the pool.
static void | PostDestructor (size_t index)
| Dummy function called after destructor of each member.
static Pool::IterateWrapper< Titem > | Iterate (size_t from=0)
| Returns an iterable ensemble of all valid Titem.

## Detailed Description

Struct about stories, current and completed.

Definition at line 167 of file story_base.h.

## Constructor & Destructor Documentation

## ◆ StoryPage() [1/2]

StoryPage::StoryPage | ( |  | ) |
| inline

We need an (empty) constructor so struct isn't zeroed (as C++ standard states)

Definition at line 177 of file story_base.h.

## ◆ StoryPage() [2/2]

StoryPage::StoryPage | ( | uint32_t | sort_value,
|  | TimerGameCalendar::Date | date,
|  | CompanyID | company,
|  | const EncodedString & | title
| ) |  |
| inline

Definition at line 178 of file story_base.h.

## ◆ ~StoryPage()

StoryPage::~StoryPage | ( |  | ) |

Definition at line 40 of file story.cpp.

## Field Documentation

## ◆ company

CompanyID StoryPage::company = CompanyID::Invalid()

StoryPage is for a specific company; CompanyID::Invalid() if it is global.

Definition at line 170 of file story_base.h.

Referenced by CmdShowStoryPage(), and CmdStoryPageButton().

## ◆ date

TimerGameCalendar::Date StoryPage::date {}

Date when the page was created.

Definition at line 169 of file story_base.h.

Referenced by CmdSetStoryPageDate(), and StoryBookWindow::DrawWidget().

## ◆ sort_value

uint32_t StoryPage::sort_value = 0

A number that increases for every created story page. Used for sorting. The id of a story page is the pool index.

Definition at line 168 of file story_base.h.

Referenced by STPAChunkHandler::Load(), and StoryBookWindow::PageOrderSorter().

## ◆ title

EncodedString StoryPage::title

Title of story page.

Definition at line 172 of file story_base.h.

Referenced by CmdSetStoryPageTitle(), StoryBookWindow::DrawWidget(), StoryBookWindow::GetHeadHeight(), StoryBookWindow::GetWidgetString(), StoryBookWindow::RefreshSelectedPage(), and StoryBookWindow::UpdateWidgetSize().

The documentation for this struct was generated from the following files:

- src/story_base.h
- src/story.cpp